"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AfterHighlightNodeEvent = exports.AfterHighlightEvent = exports.AfterAnalyzeEvent = exports.BeforeAnalyzeEvent = exports.AfterTokenizeEvent = exports.BeforeTokenizeEvent = exports.BeforeHighlightEvent = exports.BeforeHighlightNodeEvent = void 0;

// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.
class EventClass {
  constructor() {
    this.delegates = [];
  }

  addListener(callback) {
    this.delegates.push(callback);
  }

  raise(highlighter, eventArgs) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = this.delegates[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var delegate = _step.value;
        delegate(highlighter, eventArgs);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

}

var BeforeHighlightNodeEvent = new EventClass();
exports.BeforeHighlightNodeEvent = BeforeHighlightNodeEvent;
var BeforeHighlightEvent = new EventClass();
exports.BeforeHighlightEvent = BeforeHighlightEvent;
var BeforeTokenizeEvent = new EventClass();
exports.BeforeTokenizeEvent = BeforeTokenizeEvent;
var AfterTokenizeEvent = new EventClass();
exports.AfterTokenizeEvent = AfterTokenizeEvent;
var BeforeAnalyzeEvent = new EventClass();
exports.BeforeAnalyzeEvent = BeforeAnalyzeEvent;
var AfterAnalyzeEvent = new EventClass();
exports.AfterAnalyzeEvent = AfterAnalyzeEvent;
var AfterHighlightEvent = new EventClass();
exports.AfterHighlightEvent = AfterHighlightEvent;
var AfterHighlightNodeEvent = new EventClass();
exports.AfterHighlightNodeEvent = AfterHighlightNodeEvent;