"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.operators = exports.namedIdentRules = exports.identAfterFirstLetter = exports.identFirstLetter = exports.customParseRules = exports.scopes = exports.customTokens = exports.keywords = exports.name = void 0;

var util = _interopRequireWildcard(require("../util.js"));

var _regexp = require("./common/regexp.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var name = "javascript";
exports.name = name;
var keywords = [// keywords
"break", "case", "catch", "continue", "default", "delete", "do", "else", "finally", "for", "function", "if", "in", "instanceof", "new", "return", "switch", "this", "throw", "try", "typeof", "var", "void", "while", "with", // literals
"true", "false", "null"];
exports.keywords = keywords;
var customTokens = {
  reservedWord: {
    values: ["abstract", "boolean", "byte", "char", "class", "const", "debugger", "double", "enum", "export const", "extends", "final", "float", "goto", "implements", "import", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "super", "synchronized", "throws", "transient", "volatile"],
    boundary: "\\b"
  },
  globalVariable: {
    values: ["NaN", "Infinity", "undefined"],
    boundary: "\\b"
  },
  globalFunction: {
    values: ["encodeURI", "encodeURIComponent", "decodeURI", "decodeURIComponent", "parseInt", "parseFloat", "isNaN", "isFinite", "eval"],
    boundary: "\\b"
  },
  globalObject: {
    values: ["Math", "JSON", "XMLHttpRequest", "XDomainRequest", "ActiveXObject", "Boolean", "Date", "Array", "Image", "Function", "Object", "Number", "RegExp", "String"],
    boundary: "\\b"
  }
};
exports.customTokens = customTokens;
var scopes = {
  string: [['"', '"', util.escapeSequences.concat(['\\"']), false], ["'", "'", util.escapeSequences.concat(["\\'", "\\\\"]), false]],
  comment: [["//", "\n", [], true], ["/*", "*/", [], false]]
};
exports.scopes = scopes;
var customParseRules = [_regexp.ParseRegExpLiteral];
exports.customParseRules = customParseRules;
var identFirstLetter = /[$A-Za-z_]/;
exports.identFirstLetter = identFirstLetter;
var identAfterFirstLetter = /[\w$]/;
exports.identAfterFirstLetter = identAfterFirstLetter;
var namedIdentRules = {
  follows: [[{
    token: "keyword",
    values: ["function"]
  }, util.whitespace]]
};
exports.namedIdentRules = namedIdentRules;
var operators = [// arithmetic
"++", "+=", "+", "--", "-=", "-", "*=", "*", "/=", "/", "%=", "%", // boolean
"&&", "||", // bitwise
"|=", "|", "&=", "&", "^=", "^", ">>>=", ">>>", ">>=", ">>", "<<=", "<<", // inequality
"<=", "<", ">=", ">", "===", "==", "!==", "!=", // unary
"!", "~", // other
"?", ":", ".", "="];
exports.operators = operators;