"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.operators = exports.namedIdentRules = exports.identAfterFirstLetter = exports.identFirstLetter = exports.scopes = exports.customTokens = exports.keywords = exports.name = void 0;

var util = _interopRequireWildcard(require("../util.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.
var name = "sln";
exports.name = name;
var keywords = ["Project", "EndProject", "GlobalSection", "Global", "EndGlobalSection", "EndGlobal"];
exports.keywords = keywords;
var customTokens = {
  sectionName: {
    values: ["preSolution", "postSolution"],
    boundary: "\\b"
  }
};
exports.customTokens = customTokens;
var scopes = {
  string: [['"', '"', ['\\"', "\\\\"], false]],
  comment: [["#", "\n", [], true]],
  guid: [["{", "}", [], false]],
  formatDeclaration: [["Microsoft Visual Studio Solution File, Format Version", "\n", [], true]]
};
exports.scopes = scopes;
var identFirstLetter = /[A-Za-z_.]/;
exports.identFirstLetter = identFirstLetter;
var identAfterFirstLetter = /[\w-.]/;
exports.identAfterFirstLetter = identAfterFirstLetter;
var namedIdentRules = {
  follows: [[{
    token: "keyword",
    values: ["GlobalSection"]
  }, util.whitespace, {
    token: "punctuation",
    values: ["("]
  }, util.whitespace]]
};
exports.namedIdentRules = namedIdentRules;
var operators = ["=", "|"];
exports.operators = operators;