"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.highlightAll = highlightAll;
Object.defineProperty(exports, "Highlighter", {
  enumerable: true,
  get: function get() {
    return _highlighter.Highlighter;
  }
});
Object.defineProperty(exports, "defaultAnalyzer", {
  enumerable: true,
  get: function get() {
    return _defaultHelpers.defaultAnalyzer;
  }
});
Object.defineProperty(exports, "globalOptions", {
  enumerable: true,
  get: function get() {
    return _globalOptions.globalOptions;
  }
});
Object.defineProperty(exports, "registerLanguage", {
  enumerable: true,
  get: function get() {
    return _languages.registerLanguage;
  }
});
Object.defineProperty(exports, "isRegistered", {
  enumerable: true,
  get: function get() {
    return _languages.isRegistered;
  }
});
Object.defineProperty(exports, "getCSSSync", {
  enumerable: true,
  get: function get() {
    return _styles.getCSSSync;
  }
});

var _highlighter = require("./highlighter.js");

var _registerLanguages = require("./register-languages.js");

require("./load-plugins.js");

var _defaultHelpers = require("./default-helpers.js");

var _globalOptions = require("./globalOptions.js");

var _languages = require("./languages.js");

var _styles = require("./styles.js");

// sunlight-x: Intelligent Syntax Highlighting, Modernized
// Copyright 2017 Leung Wing-chung. All rights reserved.
// Use of this source code is governed by a Apache License Version 2.0, that can
// be found in the LICENSE file.
// Exports

/**
 * Highlight all code matching the given or default class prefix.
 * @param {SunlightPartialOptionsType} options
 */
function highlightAll(options) {
  var highlighter = new _highlighter.Highlighter(options);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = highlighter.getAllHighlightableNodes()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var node = _step.value;
      highlighter.highlightNode(node);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
} // Highlighter initialization


(0, _registerLanguages.registerLanguages)();